<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html"/>
  <xsl:template match="/">
    <html>
      <head>
        <title>
          <xsl:value-of select="object/name"/>
        </title>
        <link rel="stylesheet" type="text/css" media="all"
              href="../xsl.css" />      
      </head>
      <body>
        <xsl:for-each select="object">
          <h2>
            <xsl:value-of select="@name"/> : <xsl:value-of select="@meta_type"/>
          </h2> 
          <h1>Objects</h1>
          <table>
            <xsl:variable name="path">
              <xsl:choose>
                <xsl:when test="@name='portal_directories'">
                  <xsl:text>directories</xsl:text>
                </xsl:when>
                <xsl:when test="@name='portal_layouts'">
                  <xsl:text>layouts</xsl:text>
                </xsl:when>
                <xsl:when test="@name='portal_schemas'">
                  <xsl:text>schemas</xsl:text>
                </xsl:when>
                <xsl:when test="@name='portal_types'">
                  <xsl:text>types</xsl:text>
                </xsl:when>
                <xsl:when test="@name='portal_vocabularies'">
                  <xsl:text>vocabularies</xsl:text>
                </xsl:when>
                <xsl:when test="@name='portal_workflows'">
                  <xsl:text>workflows</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>xxxxxx</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
          <xsl:for-each select="object">
            <xsl:sort select="@name"
                      order="ascending" />
            <xsl:variable name="color">
              <xsl:choose>
                <xsl:when test="position() mod 2 = 0">
                  <xsl:text>#ffffff</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>#eeeeee</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <tr style="background-color:{$color}">
              <td colspan="">
                <xsl:value-of select="@name"/>
              </td>
              <td colspan="">
                <a href="{$path}/{@name}.xml"><xsl:value-of select="@name"/></a>
              </td>
              <td colspan="">
                <xsl:value-of select="@meta_type"/>
              </td>
            </tr>
          </xsl:for-each>
        </table>
        </xsl:for-each>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
